;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Command button event handler
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Needs:
	;*----------------------------------------------------------------------
;To be executed at every clock interrupt or even more often 

	sbrs	zs_flags,b_pressed
	rjmp	l_end_button_event
	cbr	zs_flags,1<<b_pressed
				;pression is handled
	m_buzz	0, 0, 1, 0	;short buzz
	cpi	z_status,s_programming_exit
	brsh	l_check_programming_status
	cpi	z_status,s_inactive+1
	brlo	l_inactive_status
l_inactive_diagn_end:
	rcall	l_inactive_diagn
	rjmp	l_end_button_event
l_inactive_status:
	rcall	l_exit
	rjmp	l_end_button_event

l_check_programming_status:
	cpi	z_status,s_programming_auto_guard
	brne	l_program_timer
	ldi	z_tmp,0xFD	;automatic turn-on timer	(msb)
	mov	z_tmp1,z_tmp	;  (0xFD20 s = 64800 s = 18 h)
	ldi	z_tmp,e_turn_on_timer_1
	rcall	l_write_eeprom
	ldi	z_tmp,0x20	;automatic turn-on timer	(lsb)
	mov	z_tmp1,z_tmp
	ldi	z_tmp,e_turn_on_timer_0
	rcall	l_write_eeprom
	rjmp	l_inactive_diagn_end

l_program_timer:
	mov	z_tmp1,z_alarm_timer_0
	neg	z_tmp1		;z_tmp1 = 256 - z_tmp1
	mov	z_tmp,z_status
	lsl	z_tmp
	subi	z_tmp,(s_programming_exit*2)-e_exit_timer_0
	rcall	l_write_eeprom
	inc	z_status
	cpi	z_status,s_programming_guard
	brne	l_programming_end
	inc	z_status
l_programming_end:
	rcall	l_programming_reset_timer
	cpi	z_status,s_programming_auto_guard
	brne	l_end_button_event
	ldi	z_alarm_timer_0,5
l_end_button_event:
