;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Read/Write EEPROM procedures
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Read EEPROM procedures
	;*----------------------------------------------------------------------
;l_read_eeprom: read byte from EEPROM
;INPUT	: z_tmp  = EEPROM address
;OUTPUT	: z_tmp1 = read data
;REGISTERS DESTROYED: none

;l_read_eeprom_word: read word from EEPROM
;INPUT	: z_tmp  = EEPROM address (first byte = msb)
;OUTPUT	: z_tmp2 = read data (msb)
;	: z_tmp1 = read data (lsb)
;REGISTERS DESTROYED: z_tmp (incremented by 1)

l_read_eeprom_word:
	out	EEAR,z_tmp	;output address
	sbi	EECR,EERE	;set EEPROM Read strobe
	in	z_tmp2,EEDR	;read data
	inc	z_tmp		;increment address
l_read_eeprom:
	out	EEAR,z_tmp	;output address
	sbi	EECR,EERE	;set EEPROM Read strobe
	in	z_tmp1,EEDR	;read data
	ret

	;*----------------------------------------------------------------------
	;* Write EEPROM procedures
	;*----------------------------------------------------------------------
;l_write_eeprom: write byte to EEPROM
;INPUT	: z_tmp  = EEPROM address
;	: z_tmp1 = data to be written
;OUTPUT	: none
;REGISTERS DESTROYED: none

;l_set_eeprom_bits: set bits in EEPROM byte
;INPUT	: z_tmp = EEPROM byte address, z_tmp2 = bits to be set in EEPROM byte
;OUTPUT	: z_tmp1 = new EEPROM byte value
;REGISTERS DESTROYED: none

l_update_power_status_eeprom:
	ldi	z_tmp,e_power_status
				;set address = power status
l_set_eeprom_bits:
	out	EEAR,z_tmp	;output address
	sbi	EECR,EERE	;set EEPROM Read strobe
	in	z_tmp1,EEDR	;read data
	or	z_tmp1,z_tmp2	;calculate new status
;*	rjmp	l_write_eeprom	;write new status to eeprom + ret

l_write_eeprom:
	out	EEAR,z_tmp	;output address
	sbi	EECR,EERE	;set EEPROM Read strobe
	in	z_tmp,EEDR	;read data
	cp	z_tmp,z_tmp1	;if data is different
	breq	l_end_write_eeprom
				;then
	out	EEDR,z_tmp1	;  output data
	sbi	EECR,EEWE	;  set EEPROM Write strobe
l_wait_end_write:
	sbic	EECR,EEWE	;  if EEWE not clear
	rjmp	l_wait_end_write;  then wait more
l_end_write_eeprom:		;fi
	in	z_tmp,EEAR	;restore z_tmp
l_ret_eeprom:
	ret

