;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Interrupt vectors
;*==============================================================================

	.org	INT0addr
	rjmp	l_int0		;external interrupt handler

	.org	OVF0addr
;*	rjmp	l_tim0_ovf	;timer0 overflow handler

;*	.org	ACIaddr
;*	reti			;analog comparator handler (not used)

;*******************************************************************************
;* tim0_ovf - Timer/Counter 0 overflow interrupt procedure.
;* This routine increments the interrupt counter.
;*******************************************************************************
l_tim0_ovf:
	in	zq_sr,SREG	;store status register
	inc	z_int_count	;increment interrupt counter
l_interrupt_end:
	out	SREG,zq_sr	;restore status register
	reti			;return from interrupt

;*******************************************************************************
;* int0 - External interrupt 0 procedure.
;* This routine sets the button pressed flag.
;*******************************************************************************
l_int0:
	in	zq_sr,SREG	;store status register
	sbr	zs_flags,1<<b_pressed
				;set pressed button flag
	rjmp	l_interrupt_end

;*==============================================================================
;* Interrupts initialization
;*==============================================================================
.macro m_int_init
	;*----------------------------------------------------------------------
	;* Timer0 overflow interrupt initialization
	;*----------------------------------------------------------------------
	ldi	z_tmp,0b00000010;s_presc_bmp
	out	TCCR0,z_tmp	;start timer and set clock source
;*	ldi	z_tmp,0b00000010;T/C0 overflow interrupt
	out	TIMSK,z_tmp	;enable T/C0 overflow interrupt

	;*----------------------------------------------------------------------
	;* External int0 interrupt initialization
	;*----------------------------------------------------------------------
;*	ldi	z_tmp,0b00000010;sleep disabled, int0 on falling edge
	out	MCUCR,z_tmp
	ldi	z_tmp,0b01000000;external int0 enabled
	out	GIMSK,z_tmp

	;*----------------------------------------------------------------------
	;* Analog comparator initialization
	;*----------------------------------------------------------------------
	sbi	ACSR,ACD	;turn off analog comparator to save 0.6 mA

	sei			;enable interrupts

	clr	z_int_count	;interrupt counter:=0
	clr	zs_flags	;done after "sei" to avoid
				;spurious interrupts interferences
.endmacro
