;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Maintenance timer handling
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Needs:
	;*----------------------------------------------------------------------
;To be called every 1 s

;*==============================================================================
;* Check maint timer: 1 s .. 18 h 12 m 16 s (used for maint. & auto power off)
;*==============================================================================
	sbrs	z_pinsd_val,b_power_low_in
				;if not power low
				;then
	m_fix_power_on		;  power on
				;fi
	subi	z_maint_timer_0,1
				;decrement maint timer - auto power off timer
				;if power off timer expired
	brne	l_power_check_end
				;then
	sbrc	z_pinsd_val,b_power_low_in
				;  if power low (battery low)
				;  then
	m_fix_power_off		;    auto power off (in order not to
				;    discharge completely the battery
				;    and damage it, and also avoid false
				;    alarms due to sensors' instability)
				;  fi
l_power_check_end:		;fi
	sbci	z_maint_timer_1,0
				;if maintenance timer expired
	brne	l_end_maint_timer
				;then
				;  timer := 18 h 12 m 16 s
	inc	z_bat_test_status
				;  status := status + 1
	sbrc	z_bat_test_status,0
				;  if status is even
	rjmp	l_stop_bat_test_3
				;  then
	ldi	z_maint_timer_0,10
				;    timer := 10 s
	brne	l_start_bat_test_3
				;    if status = 0
				;    then
;l_status_is_0_3:
	ldi	z_maint_timer_1,14
				;      timer := 3594 s (59 m 54 s)
				;        (Assuming a dummy load of 22 ohm -
				;         6.7 W at 12.1 V, 550 mA (8 W at
				;         13,27 V) - plus a stand-by load of
				;         50 mA, the total load is 600 mA for
				;         one hour.
				;         If the test is passed a residual
				;         battery capacity of 600 mAh is
				;         guaranteed, which means a
				;         guaranteed stand-by time of 12 hours
				;         at 50 mA stand-by load.)
l_start_bat_test_3:		;    fi
	cpi	z_status,s_alarm;    if not alarm status
	breq	l_end_bat_test_3;    then
	m_start_bat_test	;      start battery test
	sbrc	z_pinsd_val,b_mains_absence
				;      if mains is absent
				;      then
				;        stop battery test
				;      fi
				;    else
l_stop_bat_test_3:
	m_stop_bat_test		;    stop battery test
l_end_bat_test_3:		;  fi
l_end_maint_timer:		;fi

