;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Maintenance event handler
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Needs:
	;*----------------------------------------------------------------------
;To be called after every clock interrupt or as often as possible

	;*----------------------------------------------------------------------
	;* Check transitions of PORTD
	;*----------------------------------------------------------------------
;l_change_detection_port_d:
	in	z_pinsd_new,PIND;read input pins

		;*//////////////////////////////////////////////////////////////
		;* Power supply low:
		;*//////////////////////////////////////////////////////////////
	sbrs	z_pinsd_val,b_power_low_in
					;if power was not low
	sbrs	z_pinsd_new,b_power_low_in
					;   and is now low
	rjmp	l_end_check_battery_low	;then
;l_battery_low:
	ldi	z_tmp2,1<<b_power_low	;  set power low bit
	sbic	PORTD,b_battery_test	;  if battery test is running
					;  then
	lsr	z_tmp2			;    reset power low bit
					;    set broken battery bit
					;  fi
	m_stop_bat_test			;  stop battery test if running
	rcall	l_update_power_status_eeprom
					;  update power status in eeprom
	ldi	z_maint_timer_0,0	;  load timeout for auto power off
					;    (4 m 16 s)
					;fi
l_end_check_battery_low:

		;*//////////////////////////////////////////////////////////////
		;* Mains absence:
		;*//////////////////////////////////////////////////////////////
	sbrs	z_pinsd_val,b_mains_absence
					;if mains was not absent
	sbrs	z_pinsd_new,b_mains_absence
					;   and is now absent
	rjmp	l_end_check_mains_absence
					;then
;l_mains_absence:
	ldi	z_tmp2,1<<b_mains_failure
					;  set mains failure bit
	m_stop_bat_test			;  stop battery test if running
	rcall	l_update_power_status_eeprom
					;  update power status in eeprom
l_end_check_mains_absence:		;fi
l_end_pind_on:			;      fi
	mov	z_pinsd_val,z_pinsd_new
				;      store validated value of pins D
;l_end_change_detection_port_d:	;
