;****************** HOUSE BURGLAR ALARM / ANTIFURTO PER CASA *******************
;*
;* Title/titolo:	House burglar alarm/Antifurto per casa
;* Version/Versione:	2.0 (version for Elettronica In/
;*			     versione per Elettronica In)
;* Author/Autore:	Guido Bertolotti - guidobertolotti@yahoo.com
;* Target/Destinazione:	AT90S1200
;*
;*                      *** Main file to compile is antif.asm ***
;*                 *** Il file principale da compilare  antif.asm ***
;*
;*******************************************************************************

;*==============================================================================
;* Maintenance status machine
;*==============================================================================


;*==============================================================================
;* Maintenance initialization
;*==============================================================================
.macro m_maint_init
	;*----------------------------------------------------------------------
	;* Port D initialization
	;*----------------------------------------------------------------------
	ldi	z_tmp,s_portd_outputs
	out	DDRD,z_tmp	;set port D as inputs + outputs
	ldi	z_tmp,(1<<b_mains_absence)+(1<<b_command)
	out	PORTD,z_tmp	;pullup on 2 inputs (b_power output is low, will
				;be set to 1 later on in PORTD change detection)
	;*----------------------------------------------------------------------
	;* Power status initialization
	;*----------------------------------------------------------------------
	ldi	z_tmp2,1<<b_micro_restart
	rcall	l_update_power_status_eeprom
				;update power status in eeprom

	;*----------------------------------------------------------------------
	;* Variables initialization
	;*----------------------------------------------------------------------
	clr	z_bat_test_status
				;initial battery test status = 0
	clr	z_pinsd_val	;expected initial status of port D inputs

.endmacro

;*==============================================================================
;* Power macros and procedures
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Power on/off macros
	;*----------------------------------------------------------------------

.macro m_fix_power_on
	sbi	PORTD,b_power	;power on
.endmacro

.macro m_fix_power_off
	cbi	PORTD,b_power	;power off
.endmacro

;*==============================================================================
;* Battery macros and procedures
;*==============================================================================
	;*----------------------------------------------------------------------
	;* Battery macros
	;*----------------------------------------------------------------------

.macro m_start_bat_test		;this macro must be one-instruction long
				;(in order to be able to use instructions
				;sbrc and sbrs before calling it)
	sbi	PORTD,b_battery_test
				;start battery test
.endmacro

.macro m_stop_bat_test		;this macro must be one-instruction long
				;(in order to be able to use instructions
				;sbrc and sbrs before calling it)
	cbi	PORTD,b_battery_test
				;stop battery test
.endmacro
